/**
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
/**
 * Autogenerated by Thrift Compiler (0.9.3)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.apache.airavata.cloud.aurora.client.sdk;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
/**
 * Result of the startUpdate call.
 */
@Generated(value = "Autogenerated by Thrift Compiler (0.9.3)", date = "2016-10-21")
public class StartJobUpdateResult implements org.apache.thrift.TBase<StartJobUpdateResult, StartJobUpdateResult._Fields>, java.io.Serializable, Cloneable, Comparable<StartJobUpdateResult> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("StartJobUpdateResult");

  private static final org.apache.thrift.protocol.TField KEY_FIELD_DESC = new org.apache.thrift.protocol.TField("key", org.apache.thrift.protocol.TType.STRUCT, (short)1);
  private static final org.apache.thrift.protocol.TField UPDATE_SUMMARY_FIELD_DESC = new org.apache.thrift.protocol.TField("updateSummary", org.apache.thrift.protocol.TType.STRUCT, (short)2);

  private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
  static {
    schemes.put(StandardScheme.class, new StartJobUpdateResultStandardSchemeFactory());
    schemes.put(TupleScheme.class, new StartJobUpdateResultTupleSchemeFactory());
  }

  /**
   * Unique identifier for the job update.
   */
  public JobUpdateKey key; // required
  /**
   * Summary of the update that is in progress for the given JobKey.
   */
  public JobUpdateSummary updateSummary; // optional

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    /**
     * Unique identifier for the job update.
     */
    KEY((short)1, "key"),
    /**
     * Summary of the update that is in progress for the given JobKey.
     */
    UPDATE_SUMMARY((short)2, "updateSummary");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // KEY
          return KEY;
        case 2: // UPDATE_SUMMARY
          return UPDATE_SUMMARY;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final _Fields optionals[] = {_Fields.UPDATE_SUMMARY};
  public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.KEY, new org.apache.thrift.meta_data.FieldMetaData("key", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, JobUpdateKey.class)));
    tmpMap.put(_Fields.UPDATE_SUMMARY, new org.apache.thrift.meta_data.FieldMetaData("updateSummary", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, JobUpdateSummary.class)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(StartJobUpdateResult.class, metaDataMap);
  }

  public StartJobUpdateResult() {
  }

  public StartJobUpdateResult(
    JobUpdateKey key)
  {
    this();
    this.key = key;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public StartJobUpdateResult(StartJobUpdateResult other) {
    if (other.isSetKey()) {
      this.key = new JobUpdateKey(other.key);
    }
    if (other.isSetUpdateSummary()) {
      this.updateSummary = new JobUpdateSummary(other.updateSummary);
    }
  }

  public StartJobUpdateResult deepCopy() {
    return new StartJobUpdateResult(this);
  }

  @Override
  public void clear() {
    this.key = null;
    this.updateSummary = null;
  }

  /**
   * Unique identifier for the job update.
   */
  public JobUpdateKey getKey() {
    return this.key;
  }

  /**
   * Unique identifier for the job update.
   */
  public StartJobUpdateResult setKey(JobUpdateKey key) {
    this.key = key;
    return this;
  }

  public void unsetKey() {
    this.key = null;
  }

  /** Returns true if field key is set (has been assigned a value) and false otherwise */
  public boolean isSetKey() {
    return this.key != null;
  }

  public void setKeyIsSet(boolean value) {
    if (!value) {
      this.key = null;
    }
  }

  /**
   * Summary of the update that is in progress for the given JobKey.
   */
  public JobUpdateSummary getUpdateSummary() {
    return this.updateSummary;
  }

  /**
   * Summary of the update that is in progress for the given JobKey.
   */
  public StartJobUpdateResult setUpdateSummary(JobUpdateSummary updateSummary) {
    this.updateSummary = updateSummary;
    return this;
  }

  public void unsetUpdateSummary() {
    this.updateSummary = null;
  }

  /** Returns true if field updateSummary is set (has been assigned a value) and false otherwise */
  public boolean isSetUpdateSummary() {
    return this.updateSummary != null;
  }

  public void setUpdateSummaryIsSet(boolean value) {
    if (!value) {
      this.updateSummary = null;
    }
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case KEY:
      if (value == null) {
        unsetKey();
      } else {
        setKey((JobUpdateKey)value);
      }
      break;

    case UPDATE_SUMMARY:
      if (value == null) {
        unsetUpdateSummary();
      } else {
        setUpdateSummary((JobUpdateSummary)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case KEY:
      return getKey();

    case UPDATE_SUMMARY:
      return getUpdateSummary();

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case KEY:
      return isSetKey();
    case UPDATE_SUMMARY:
      return isSetUpdateSummary();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof StartJobUpdateResult)
      return this.equals((StartJobUpdateResult)that);
    return false;
  }

  public boolean equals(StartJobUpdateResult that) {
    if (that == null)
      return false;

    boolean this_present_key = true && this.isSetKey();
    boolean that_present_key = true && that.isSetKey();
    if (this_present_key || that_present_key) {
      if (!(this_present_key && that_present_key))
        return false;
      if (!this.key.equals(that.key))
        return false;
    }

    boolean this_present_updateSummary = true && this.isSetUpdateSummary();
    boolean that_present_updateSummary = true && that.isSetUpdateSummary();
    if (this_present_updateSummary || that_present_updateSummary) {
      if (!(this_present_updateSummary && that_present_updateSummary))
        return false;
      if (!this.updateSummary.equals(that.updateSummary))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    List<Object> list = new ArrayList<Object>();

    boolean present_key = true && (isSetKey());
    list.add(present_key);
    if (present_key)
      list.add(key);

    boolean present_updateSummary = true && (isSetUpdateSummary());
    list.add(present_updateSummary);
    if (present_updateSummary)
      list.add(updateSummary);

    return list.hashCode();
  }

  @Override
  public int compareTo(StartJobUpdateResult other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = Boolean.valueOf(isSetKey()).compareTo(other.isSetKey());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetKey()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.key, other.key);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetUpdateSummary()).compareTo(other.isSetUpdateSummary());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetUpdateSummary()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.updateSummary, other.updateSummary);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("StartJobUpdateResult(");
    boolean first = true;

    sb.append("key:");
    if (this.key == null) {
      sb.append("null");
    } else {
      sb.append(this.key);
    }
    first = false;
    if (isSetUpdateSummary()) {
      if (!first) sb.append(", ");
      sb.append("updateSummary:");
      if (this.updateSummary == null) {
        sb.append("null");
      } else {
        sb.append(this.updateSummary);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
    if (key != null) {
      key.validate();
    }
    if (updateSummary != null) {
      updateSummary.validate();
    }
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
    try {
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class StartJobUpdateResultStandardSchemeFactory implements SchemeFactory {
    public StartJobUpdateResultStandardScheme getScheme() {
      return new StartJobUpdateResultStandardScheme();
    }
  }

  private static class StartJobUpdateResultStandardScheme extends StandardScheme<StartJobUpdateResult> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, StartJobUpdateResult struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // KEY
            if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
              struct.key = new JobUpdateKey();
              struct.key.read(iprot);
              struct.setKeyIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // UPDATE_SUMMARY
            if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
              struct.updateSummary = new JobUpdateSummary();
              struct.updateSummary.read(iprot);
              struct.setUpdateSummaryIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, StartJobUpdateResult struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.key != null) {
        oprot.writeFieldBegin(KEY_FIELD_DESC);
        struct.key.write(oprot);
        oprot.writeFieldEnd();
      }
      if (struct.updateSummary != null) {
        if (struct.isSetUpdateSummary()) {
          oprot.writeFieldBegin(UPDATE_SUMMARY_FIELD_DESC);
          struct.updateSummary.write(oprot);
          oprot.writeFieldEnd();
        }
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class StartJobUpdateResultTupleSchemeFactory implements SchemeFactory {
    public StartJobUpdateResultTupleScheme getScheme() {
      return new StartJobUpdateResultTupleScheme();
    }
  }

  private static class StartJobUpdateResultTupleScheme extends TupleScheme<StartJobUpdateResult> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, StartJobUpdateResult struct) throws org.apache.thrift.TException {
      TTupleProtocol oprot = (TTupleProtocol) prot;
      BitSet optionals = new BitSet();
      if (struct.isSetKey()) {
        optionals.set(0);
      }
      if (struct.isSetUpdateSummary()) {
        optionals.set(1);
      }
      oprot.writeBitSet(optionals, 2);
      if (struct.isSetKey()) {
        struct.key.write(oprot);
      }
      if (struct.isSetUpdateSummary()) {
        struct.updateSummary.write(oprot);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, StartJobUpdateResult struct) throws org.apache.thrift.TException {
      TTupleProtocol iprot = (TTupleProtocol) prot;
      BitSet incoming = iprot.readBitSet(2);
      if (incoming.get(0)) {
        struct.key = new JobUpdateKey();
        struct.key.read(iprot);
        struct.setKeyIsSet(true);
      }
      if (incoming.get(1)) {
        struct.updateSummary = new JobUpdateSummary();
        struct.updateSummary.read(iprot);
        struct.setUpdateSummaryIsSet(true);
      }
    }
  }

}

